############################################################## 
## MOD Title: Anti Robotic Login Flood 
## MOD Author: ESQARE < admin@phpbbturkey.com > (Alper) http://www.phpbbturkey.com/
## MOD Author: Smartor < smartor_xp@hotmail.com > (Hoang Ngoc Tu) http://smartor.is-root.com
## MOD Description:   This will add a Random-graphical-text security code field in 
##         Login form to protect your phpBB from being flooded of 
##         robotic-member-login
## MOD Version: 1.0.4 
## 
## Installation Level: Intermediate 
## Installation Time: 20 Minutes 
## Files To Edit:
##	admin/admin_board.php 
##	includes/constants.php
##	includes/functions.php
##	includes/page_header.php
##   	login.php
##   	index.php
##  	templates/subSilver/admin/board_config_body.tpl
##  	templates/subSilver/login_body.tpl
##  	templates/subSilver/index_body.tpl
##  	language/lang_english/lang_admin.php
##  	language/lang_english/lang_main.php
## 
## Included Files:
##	root/antirobot_pic_login.php
##	root/images/anti_robotic_login/anti_robotic_login_*.gif
## License: http://opensource.org/licenses/gpl-license.php GNU General Public License v2
############################################################## 
## For security purposes, please check: http://www.phpbb.com/mods/ 
## for the latest version of this MOD. Although MODs are checked 
## before being allowed in the MODs Database there is no guarantee 
## that there are no security problems within the MOD. No support 
## will be given for MODs not found within the MODs Database which 
## can be found at http://www.phpbb.com/mods/ 
############################################################## 
## Author Notes: 
##      The codes added into login_body.tpl below should also be added into all the template files 
##      which contain the login box code such as index_body.tpl and portal_body.tpl 
## 
############################################################## 
## MOD History: 
##
##   2006-04-03 - Version 1.0.4
##      - New option: Enable/Disable Security Codes on admin control panel 
##
##   2006-09-02 - Version 1.0.3
##      - Changed anti_robotic_login images
##      - Updated install.txt
##      - Changed any codes in anti_robot_pic_login.php file
##      - Added new numeric characters
##
##   2006-04-01 - Version 1.0.2
##      - Updated codes
##      - MOD works left with Smartor's Anti Robotic Register Flood
##
##   2006-02-01 - Version 1.0.1 
##      - Change a few bugs in install.txt
##
##   2006-01-01 - Version 1.0.0 
##      - First release
## 
############################################################## 
## Before Adding This MOD To Your Forum, You Should Back Up All Files Related To This MOD 
############################################################## 

#
#-----[ SQL ]---------------------------------------------
#
CREATE TABLE phpbb_anti_robotic_login (
	session_id char(32) DEFAULT '' NOT NULL,
	login_key char(5) NOT NULL,
	timestamp int(11) unsigned NOT NULL,
	PRIMARY KEY (session_id)
);

INSERT INTO phpbb_config (config_name, config_value) VALUES ('allow_anti_robotic_login','1');

#
#-----[ COPY ]--------------------------------------------
#
copy root/antirobot_pic_login.php to antirobot_pic_login.php

#
#-----[ COPY ]--------------------------------------------
#
copy root/images/anti_robotic_login/anti_robotic_login_*.gif to images/anti_robotic_login/

#
#-----[ OPEN ]---------------------------------------------
#
admin/admin_board.php

#
#-----[ FIND ]---------------------------------------------
#
$board_email_form_yes = ( $new['board_email_form'] ) ? "checked=\"checked\"" : "";

#
#-----[ BEFORE, ADD ]---------------------------------------------
#
$allow_anti_robotic_login_yes = ($new['allow_anti_robotic_login']) ? 'checked="checked"' : '';
$allow_anti_robotic_login_no = (!$new['allow_anti_robotic_login']) ? 'checked="checked"' : '';


#
#-----[ FIND ]---------------------------------------------
#
	"L_VISUAL_CONFIRM_EXPLAIN" => $lang['Visual_confirm_explain'], 

#
#-----[ AFTER, ADD ]---------------------------------------------
#
	"L_ALLOW_ANTI_ROBOTIC_LOGIN" => $lang['Allow_anti_robotic'],
	"L_ALLOW_ANTI_ROBOTIC_LOGIN_EXPLAIN" => $lang['Allow_anti_robotic_explain'],

#
#-----[ FIND ]---------------------------------------------
#
	"CONFIRM_DISABLE" => $confirm_no,

#
#-----[ AFTER, ADD ]---------------------------------------------
#
	'ALLOW_ANTI_ROBOTIC_LOGIN_YES' => $allow_anti_robotic_login_yes,
	'ALLOW_ANTI_ROBOTIC_LOGIN_NO' => $allow_anti_robotic_login_no,

#
#-----[ OPEN ]--------------------------------------------
#
includes/constants.php

#
#-----[ FIND ]--------------------------------------------
#
?>

#
#-----[ BEFORE, ADD ]-------------------------------------
#
// Anti Robotic Login 
define('ANTI_ROBOT_LOGIN_TABLE', $table_prefix.'anti_robotic_login');

#
#-----[ OPEN ]--------------------------------------------
#
includes/functions.php

# 
#-----[ FIND ]-------------------------------------------- 
# 
?> 

# 
#-----[ BEFORE, ADD ]-------------------------------------- 
# 
function gen_login_key()
{
	$key = "";
	$max_length_login_key = 5;
	$chars = array(
		"0","1","2","3","4","5","6","7","8","9",
		"a","b","c","d","e","f","g","h","i","j","k","l","m",
		"n","o","p","q","r","s","t","u","v","w","x","y","z");

	$count = count($chars) - 1;

	srand((double)microtime()*1000000);

	for($i = 0; $i < $max_length_login_key; $i++)
	{
		$key .= $chars[rand(0, $count)];
	}

	return($key);
}

#
#-----[ OPEN ]---------------------------------------------
#
includes/page_header.php

#
#-----[ FIND ]---------------------------------------------
#
if ( !$userdata['session_logged_in'] )
{
	$template->assign_block_vars('switch_user_logged_out', array());

#
#-----[ AFTER, ADD ]---------------------------------------------
#
	//
	// Allow anti robotic login?
	//
	if (!isset($board_config['allow_anti_robotic_login']) || $board_config['allow_anti_robotic_login'] )
	{
		$template->assign_block_vars('switch_allow_anti_robotic_login', array());
		$template->assign_block_vars('switch_user_logged_out.switch_allow_anti_robotic_login', array());
	}

#
#-----[ FIND ]---------------------------------------------
#
else
{
	$template->assign_block_vars('switch_user_logged_in', array());

#
#-----[ AFTER, ADD ]---------------------------------------------
#
	//
	// Allow anti robotic login? (for login to admin panel)
	//
	if (!isset($board_config['allow_anti_robotic_login']) || $board_config['allow_anti_robotic_login'] )
	{
		$template->assign_block_vars('switch_allow_anti_robotic_login', array());
		$template->assign_block_vars('switch_user_logged_in.switch_allow_anti_robotic_login', array());
	}

# 
#-----[ OPEN ]-------------------------------------------- 
# 
login.php

# 
#-----[ FIND ]-------------------------------------------- 
# 
	if( ( isset($HTTP_POST_VARS['login']) || isset($HTTP_GET_VARS['login']) ) && (!$userdata['session_logged_in'] || isset($HTTP_POST_VARS['admin'])) )
	{
		$username = isset($HTTP_POST_VARS['username']) ? phpbb_clean_username($HTTP_POST_VARS['username']) : '';
		$password = isset($HTTP_POST_VARS['password']) ? $HTTP_POST_VARS['password'] : '';

# 
#-----[ AFTER, ADD ]-------------------------------------- 
# 
	//
	// Anti Robotic Login
	//
	if ($board_config['allow_anti_robotic_login'])
	{
		$sql = "SELECT * FROM " . ANTI_ROBOT_LOGIN_TABLE . " WHERE session_id = '" . $userdata['session_id'] . "' LIMIT 1";
		if( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not obtain login information', '', __LINE__, __FILE__, $sql);
		}

		$anti_robot_row = $db->sql_fetchrow($result);
 
		if (( strtolower($HTTP_POST_VARS['login_key']) != $anti_robot_row['login_key'] ) or ($anti_robot_row['login_key'] == ''))
		{
					$redirect = ( !empty($HTTP_POST_VARS['redirect']) ) ? str_replace('&amp;', '&', htmlspecialchars($HTTP_POST_VARS['redirect'])) : '';
					$redirect = str_replace('?', '&', $redirect);

					if (strstr(urldecode($redirect), "\n") || strstr(urldecode($redirect), "\r"))
					{
						message_die(GENERAL_ERROR, 'Tried to redirect to potentially insecure url.');
					}

					$template->assign_vars(array(
						'META' => "<meta http-equiv=\"refresh\" content=\"3;url=login.$phpEx?redirect=$redirect\">")
					);
					$error = $lang['Wrong_login_key'] . '<br /><br />' . sprintf($lang['Click_return_login'], "<a href=\"login.$phpEx?redirect=$redirect\">", '</a>') . '<br /><br />' .  sprintf($lang['Click_return_index'], '<a href="' . append_sid("index.$phpEx") . '">', '</a>');
					message_die(GENERAL_MESSAGE, $error);
		}
		else
		{
			$sql = "DELETE FROM " . ANTI_ROBOT_LOGIN_TABLE . " WHERE session_id = '" . $userdata['session_id'] . "'";
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Could not delete security code key', '', __LINE__, __FILE__, $sql);
			}
		}
	}
	// --------------------------
	//

# 
#-----[ FIND ]-------------------------------------------- 
# 
      make_jumpbox('viewforum.'.$phpEx); 

# 
#-----[ BEFORE, ADD ]------------------------------------- 
# 		
	//
	// Anti Robotic Login
	if ($board_config['allow_anti_robotic_login'])
	{ 
		$sql = "DELETE FROM " . ANTI_ROBOT_LOGIN_TABLE . " WHERE timestamp < '" . (time() - 3600) . "' OR session_id = '" . $userdata['session_id'] . "'";
		if( !$result = $db->sql_query($sql) )
		{
				message_die(GENERAL_ERROR, 'Could not delete security key', '', __LINE__, __FILE__, $sql);
		}

		$login_key = gen_login_key();

		$sql = "INSERT INTO ". ANTI_ROBOT_LOGIN_TABLE . " VALUES ('" . $userdata['session_id'] . "', '" . $login_key . "', '" . time() . "')";
		if( !$result = $db->sql_query($sql) )
		{
				message_die(GENERAL_ERROR, 'Could not check login information', '', __LINE__, __FILE__, $sql);
		}
	} 
	//-----------------------
	//
# 
#-----[ FIND ]-------------------------------------------- 
# 
         'U_SEND_PASSWORD' => append_sid("profile.$phpEx?mode=sendpassword"), 

# 
#-----[ AFTER, ADD ]-------------------------------------- 
# 
		// Anti Robotic Login
		'L_SECURITY_CODE' => $lang['Security_code'],
		'L_SECURITY_CODE_EXPLAIN' => $lang['Security_code_explain'],
		'S_ANTI_ROBOT1' => append_sid('antirobot_pic_login.'.$phpEx.'?id=1'),
		'S_ANTI_ROBOT2' => append_sid('antirobot_pic_login.'.$phpEx.'?id=2'),
		'S_ANTI_ROBOT3' => append_sid('antirobot_pic_login.'.$phpEx.'?id=3'),
		'S_ANTI_ROBOT4' => append_sid('antirobot_pic_login.'.$phpEx.'?id=4'),
		'S_ANTI_ROBOT5' => append_sid('antirobot_pic_login.'.$phpEx.'?id=5'),
# 
#-----[ OPEN ]-------------------------------------------- 
# 
index.php

# 
#-----[ FIND ]-------------------------------------------- 
# 
	$template->assign_vars(array(
		'TOTAL_POSTS' => sprintf($l_total_post_s, $total_posts),

# 
#-----[ BEFORE, ADD ]-------------------------------------- 
# 
	//
	// Anti Robotic Login 
	if ($board_config['allow_anti_robotic_login'])
	{
		$sql = "DELETE FROM " . ANTI_ROBOT_LOGIN_TABLE . " WHERE timestamp < '" . (time() - 3600) . "' OR session_id = '" . $userdata['session_id'] . "'";
		if( !$result = $db->sql_query($sql) )
		{
				message_die(GENERAL_ERROR, 'Could not delete security code key', '', __LINE__, __FILE__, $sql);
		}

		$login_key = gen_login_key();

		$sql = "INSERT INTO ". ANTI_ROBOT_LOGIN_TABLE . " VALUES ('" . $userdata['session_id'] . "', '" . $login_key . "', '" . time() . "')";
		if( !$result = $db->sql_query($sql) )
		{
				message_die(GENERAL_ERROR, 'Could not check login information', '', __LINE__, __FILE__, $sql);
		}
	} 
	//-----------------------
	//

# 
#-----[ FIND ]-------------------------------------------- 
# 
		'L_MARK_FORUMS_READ' => $lang['Mark_all_forums'],

# 
#-----[ AFTER, ADD ]-------------------------------------- 
# 
		// Anti Robotic Login
		'L_SECURITY_CODE' => $lang['Security_code'],
		'S_ANTI_ROBOT1' => append_sid('antirobot_pic_login.'.$phpEx.'?id=1'),
		'S_ANTI_ROBOT2' => append_sid('antirobot_pic_login.'.$phpEx.'?id=2'),
		'S_ANTI_ROBOT3' => append_sid('antirobot_pic_login.'.$phpEx.'?id=3'),
		'S_ANTI_ROBOT4' => append_sid('antirobot_pic_login.'.$phpEx.'?id=4'),
		'S_ANTI_ROBOT5' => append_sid('antirobot_pic_login.'.$phpEx.'?id=5'),

#
#-----[ OPEN ]---------------------------------------------
#
templates/subSilver/admin/board_config_body.tpl

#
#
#-----[ FIND ]---------------------------------------------
#
	<tr>
		<td class="row1">{L_VISUAL_CONFIRM}<br /><span class="gensmall">{L_VISUAL_CONFIRM_EXPLAIN}</span></td>
		<td class="row2"><input type="radio" name="enable_confirm" value="1" {CONFIRM_ENABLE} />{L_YES}&nbsp; &nbsp;<input type="radio" name="enable_confirm" value="0" {CONFIRM_DISABLE} />{L_NO}</td>
	</tr>

#
#-----[ AFTER, ADD ]---------------------------------------------
#
	<tr>
		<td class="row1">{L_ALLOW_ANTI_ROBOTIC_LOGIN}<br /><span class="gensmall">{L_ALLOW_ANTI_ROBOTIC_LOGIN_EXPLAIN}</span></td>
		<td class="row2"><input type="radio" name="allow_anti_robotic_login" value="1" {ALLOW_ANTI_ROBOTIC_LOGIN_YES} />{L_YES}&nbsp; &nbsp;<input type="radio" name="allow_anti_robotic_login" value="0" {ALLOW_ANTI_ROBOTIC_LOGIN_NO} />{L_NO}</td>
	</tr>

# 
#-----[ OPEN ]-------------------------------------------- 
# 
templates/subSilver/login_body.tpl 

# 
#-----[ FIND ]-------------------------------------------- 
# 
			  <input type="password" class="post" name="password" size="25" maxlength="32" />
			</td>
		  </tr>

# 
#-----[ AFTER, ADD ]-------------------------------------- 
# 
<!-- BEGIN switch_allow_anti_robotic_login -->
	  	  <tr>
  			<td align="right"><span class="gen">{L_SECURITY_CODE}:</span></td>
  			<td>
			  <img src="{S_ANTI_ROBOT1}" alt="" border="0" /><img src="{S_ANTI_ROBOT2}" alt="" border="0" /><img src="{S_ANTI_ROBOT3}" alt="" border="0" /><img src="{S_ANTI_ROBOT4}" alt="" border="0" /><img src="{S_ANTI_ROBOT5}" alt="" border="0" />
			</td>
		  </tr>
		  <tr>
			<td align="right"><span class="gen">{L_SECURITY_CODE_EXPLAIN}:</span></td>
			<td>
			  <input type="text" class="post" name="login_key" maxlength="5" size="6" />
			</td>
	  	  </tr>
<!-- END switch_allow_anti_robotic_login -->

# 
#-----[ OPEN ]-------------------------------------------- 
# 
templates/subSilver/index_body.tpl 

# 
#-----[ FIND ]-------------------------------------------- 
# 
<!-- BEGIN switch_user_logged_out -->
<form method="post" action="{S_LOGIN_ACTION}">
  <table width="100%" cellpadding="3" cellspacing="1" border="0" class="forumline">
	<tr> 
	  <td class="catHead" height="28"><a name="login"></a><span class="cattitle">{L_LOGIN_LOGOUT}</span></td>
	</tr>
	<tr> 
	  <td class="row1" align="center" valign="middle" height="28"><span class="gensmall">{L_USERNAME}: 
		<input class="post" type="text" name="username" size="10" />
		&nbsp;&nbsp;&nbsp;{L_PASSWORD}: 
		<input class="post" type="password" name="password" size="10" maxlength="32" />
		<!-- BEGIN switch_allow_autologin -->
		&nbsp;&nbsp; &nbsp;&nbsp;{L_AUTO_LOGIN} 
		<input class="text" type="checkbox" name="autologin" />
		<!-- END switch_allow_autologin -->
		&nbsp;&nbsp;&nbsp; 
		<input type="submit" class="mainoption" name="login" value="{L_LOGIN}" />
		</span> </td>
	</tr>
  </table>
</form>
<!-- END switch_user_logged_out -->

# 
#-----[ REPLACE WITH ]-------------------------------------- 
# 
<!-- BEGIN switch_user_logged_out -->
<form method="post" action="{S_LOGIN_ACTION}">
  <table width="100%" cellpadding="3" cellspacing="1" border="0" class="forumline">
	<tr> 
	  <td class="catHead" height="28"><a name="login"></a><span class="cattitle">{L_LOGIN_LOGOUT}</span></td>
	</tr>
	<tr> 
	  <td class="row1" align="center" valign="middle"><table border="0" cellspacing="0" cellpadding="1">
	  <tr>
		<td><span class="gensmall">{L_USERNAME}:</span></td>
		<td><input class="post" type="text" name="username" size="10" /></td>
		<td><span class="gensmall">&nbsp;&nbsp;&nbsp;{L_PASSWORD}:</span></td>
		<td><input class="post" type="password" name="password" size="10" maxlength="32" /></td>
<!-- BEGIN switch_allow_anti_robotic_login -->
  		<td><span class="gensmall">&nbsp;&nbsp;&nbsp;{L_SECURITY_CODE}:</span></td>
  		<td><input class="post" type="text" name="login_key" maxlength="5" size="10" /></td>
  		<td><span class="gensmall">&nbsp;<img src="{S_ANTI_ROBOT1}" alt="" border="0" /><img src="{S_ANTI_ROBOT2}" alt="" border="0" /><img src="{S_ANTI_ROBOT3}" alt="" border="0" /><img src="{S_ANTI_ROBOT4}" alt="" border="0" /><img src="{S_ANTI_ROBOT5}" alt="" border="0" /></span></td> 
<!-- END switch_allow_anti_robotic_login -->
		<!-- BEGIN switch_allow_autologin -->
		<td><span class="gensmall">&nbsp;&nbsp; &nbsp;&nbsp;{L_AUTO_LOGIN}</span></td>
		<td width="20"><input type="checkbox" name="autologin" /></td>
		<!-- END switch_allow_autologin -->
		<td><span class="gensmall">&nbsp;&nbsp;&nbsp;</span></td>
		<td><input type="submit" class="mainoption" name="login" value="{L_LOGIN}" /></td>
	  </tr>
	</table>
  </table>
</form>
<!-- END switch_user_logged_out -->

#
#-----[ OPEN ]---------------------------------------------
#
language/lang_english/lang_admin.php

#
#-----[ FIND ]---------------------------------------------
#
//
// Forum Management
//

#
#-----[ BEFORE, ADD ]---------------------------------------------
#
// Allow - Disallow Anti robotic login
$lang['Allow_anti_robotic'] = 'Enable Security Codes';
$lang['Allow_anti_robotic_explain'] = 'Requires users enter a code defined by an image when logging.';

#
#-----[ OPEN ]--------------------------------------------
#
language/lang_english/lang_main.php

#
#-----[ FIND ]--------------------------------------------
#
?>

#
#-----[ BEFORE, ADD ]-------------------------------------
#
// Anti Robotic Login
$lang['Wrong_login_key'] = 'You have entered the wrong Security Code';
$lang['Security_code'] = 'Security Code';
$lang['Security_code_explain'] = 'Please Enter Security Code';

# 
#-----[ SAVE/CLOSE ALL FILES ]------------------------------------------ 
# 
# EoM